﻿-- Author      : Nogarder
-- Create Date : 2010/7/4 16:33:11

local GetTime=GetTime
local pairs=pairs
local table_insert=table.insert
local bit_band=bit.band
local COMBATLOG_OBJECT_TYPE_PLAYER
local table_remove=table.remove

local NPA_Tracker_Frame={}
local NPA_Tracker_FrameSlot={}
local NPA_Tracker_GUIDList={}
local NPA_Tracker_Count=0

local NPA_Tracker_TrackList={}
local floor=floor
local abs=abs

local GUIDToFrame=NPA_Core.GUIDToFrame


local NPA_Tracker={}

local COMBATLOG_OBJECT_REACTION_HOSTILE=COMBATLOG_OBJECT_REACTION_HOSTILE

local NPA_Tracker_MainFrame=CreateFrame("Frame","NPA_Tracker_Frame",UIParent)
local NPA_Tracker_SelfFrame
local NPA_Tracker_PetFrame

--config
local NPA_Tracker_DefaultSetting={
		["Tracker_Frame_UpdateInterval"]=0.03,
		["Tracker_UpdateInterval"]=0.1,

		["Tracker_OffsetX"]=-400,
		["Tracker_OffsetY"]=110,
		["Tracker_Height"]=80,
		["Tracker_Width"]=180,
		["Tracker_Size"]=1,
		["Tracker_Count"]=4,
		["Tracker_Row"]=1,
		["Tracker_LeftWard"]=0,
		["Tracker_UpWard"]=0,
		["Tracker_Hostile"]=1,
		["Tracker_NonHostile"]=0,
		["Tracker_Aura"]=1,
		["Tracker_Cast"]=0,
		["Tracker_CastOnMe"]=1,
		["Tracker_CrowdControl"]=1,
		["Tracker_TimeOut"]=45,
		["Tracker_CounterSpell"]=1,
		["Tracker_CoolDown"]=0,

		["Tracker_Self"]=1,
		["Tracker_SelfOffsetX"]=0,
		["Tracker_SelfOffsetY"]=-100,
		["Tracker_SelfSize"]=1,
		["Tracker_SelfName"]=1,
		["Tracker_SelfAlpha"]=1,

		["Tracker_Pet"]=1,
		["Tracker_PetOffsetX"]=200,
		["Tracker_PetOffsetY"]=-100,
		["Tracker_PetSize"]=1,
		["Tracker_PetName"]=1,
		["Tracker_PetAlpha"]=1,

		["Tracker_ModuleList"]={
			["Aura"]=1,
			["AutoHide"]=1,
			["CastWarning"]=1,
			["ClassIcon"]=1,
			["ComboPoint"]=1,
			["CoolDown"]=1,
			["CrowdControl"]=1,
			["HealthBar"]=1,
			["ManaBar"]=1,
			["RaidIcon"]=1,
			["Speed"]=1,
			["Target"]=1,
			["Threat"]=1,
			["QuestMark"]=1,
			["RangeCheck"]=1,
			["Tracker"]=1,
			["CounterSpell"]=1,
			["ClassInfo"]=1,
			["NameText"]=1,
			["TargetCount"]=1,
			["ShieldWatch"]=1,
			["exCombat"]=1,
			["RoleCheck"]=1,
			},

		["Tracker_SelfModuleList"]={
			["Aura"]=1,
			["AutoHide"]=1,
			["CastWarning"]=1,
			["ClassIcon"]=1,
			["ComboPoint"]=1,
			["CoolDown"]=1,
			["CrowdControl"]=1,
			["HealthBar"]=1,
			["ManaBar"]=1,
			["RaidIcon"]=1,
			["Speed"]=1,
			["Target"]=1,
			["Threat"]=1,
			["QuestMark"]=1,
			["RangeCheck"]=1,
			["Tracker"]=1,
			["CounterSpell"]=1,
			["ClassInfo"]=1,
			["NameText"]=1,
			["TargetCount"]=1,
			["ShieldWatch"]=1,
			["exCombat"]=1,
			["RoleCheck"]=1,
			},

		["Tracker_PetModuleList"]={
			["Aura"]=1,
			["AutoHide"]=1,
			["CastWarning"]=1,
			["ClassIcon"]=1,
			["ComboPoint"]=1,
			["CoolDown"]=1,
			["CrowdControl"]=1,
			["HealthBar"]=1,
			["ManaBar"]=1,
			["RaidIcon"]=1,
			["Speed"]=1,
			["Target"]=1,
			["Threat"]=1,
			["QuestMark"]=1,
			["RangeCheck"]=1,
			["Tracker"]=1,
			["CounterSpell"]=1,
			["ClassInfo"]=1,
			["NameText"]=1,
			["TargetCount"]=1,
			["ShieldWatch"]=1,
			["exCombat"]=1,
			["RoleCheck"]=1,
			},

	}
local NPA_Tracker_Config=NPA_Tracker_DefaultSetting

function NPA_Tracker:ResetConfig()
	NPA_Config["Tracker"]=CopyTable(NPA_Tracker_DefaultSetting)
end
local NPA_Tracker_Enable=0

local NPA_Tracker_CombatLogFilter={}
local function NPA_Tracker_BuildFilter()
	NPA_Tracker_CombatLogFilter={}

	if(NPA_Tracker_Config["Tracker_Aura"]==1)then
		NPA_Tracker_CombatLogFilter["SPELL_AURA_APPLIED"]=1
		NPA_Tracker_CombatLogFilter["SPELL_AURA_APPLIED_DOSE"]=1
		NPA_Tracker_CombatLogFilter["SPELL_AURA_REFRESH"]=1
	end

	if(NPA_Tracker_Config["Tracker_CounterSpell"]==1)then
		NPA_Tracker_CombatLogFilter["SPELL_INTERRUPT"]=1
	end

	if(NPA_Tracker_Config["Tracker_Cast"]==1)then
		NPA_Tracker_CombatLogFilter["SPELL_CAST_START"]=2
	elseif(NPA_Tracker_Config["Tracker_CastOnMe"]==1)then
		NPA_Tracker_CombatLogFilter["SPELL_CAST_START"]=3
	end

	if(NPA_Tracker_Config["Tracker_CoolDown"])then
		NPA_Tracker_CombatLogFilter["SPELL_CAST_SUCCESS"]=2
	end
end

--NPA_Tracker_BuildFilter()


local function NPA_Tracker_IsHostile(flag)
	local bit=bit.band(flag,COMBATLOG_OBJECT_REACTION_HOSTILE)
	if(bit>0)then
		return 1
	else
		return 0
	end
end

local function NPA_Tracker_AddTracker(arg6,arg8)
	local hostile=bit_band(arg8,COMBATLOG_OBJECT_REACTION_HOSTILE)

	if((hostile>0 and NPA_Tracker_Config["Tracker_Hostile"]==1) or
		(hostile<=0 and NPA_Tracker_Config["Tracker_NonHostile"]==1))then
		
		table_insert(NPA_Tracker_TrackList,arg6)
	end
	
end



local function NPA_Tracker_FrameTargetPosition(slot)
	if(slot>0)then
		slot=slot-1
	end
	local row
	local col
	if(NPA_Tracker_Config["Tracker_LeftWard"]==1)then
		row=-1
	else
		row=1
	end

	if(NPA_Tracker_Config["Tracker_UpWard"]==1)then
		col=1
	else
		col=-1
	end
		

	local x=(slot % NPA_Tracker_Config["Tracker_Row"]) *NPA_Tracker_Config["Tracker_Width"] * row
	local y=floor(slot / NPA_Tracker_Config["Tracker_Row"])*NPA_Tracker_Config["Tracker_Height"] * col
	
	dx,dy=NPA_Tracker_MainFrame:GetCenter()
	x=x+dx or 0
	y=y+dy or 0

	return x,y
end

local GetUnitData=NPA_Core_GetUnitData

local function NPA_Tracker_Check(frame,key)
	local main=frame[key]
	if(main and main:IsShown())then
		return 1
	else
		return nil
	end
end

local function NPA_Tracker_FrameOnUpdate(self,elapsed)
	self.TimeStack=self.TimeStack+elapsed
	if(self.TimeStack<NPA_Tracker_Config["Tracker_Frame_UpdateInterval"])then
		return
	end

	local selfguid=UnitGUID("player")
	local petguid=UnitGUID("playerpet")

	local modulemain=self.ModuleMain
	
	local show=0

	if(self.IsSelf)then
		if(selfguid)then
			self.GUID=selfguid
			GUIDToFrame[selfguid]=self
			self.ModuleMain.GUID=selfguid

			modulemain:Show()
		else
			modulemain:Hide()
		end
		return
	elseif(self.IsPet)then
		if(petguid)then
			self.GUID=petguid
			GUIDToFrame[petguid]=self
			self.ModuleMain.GUID=petguid
			modulemain:Show()
		else
			modulemain:Hide()
		end
		return
	elseif(self.GUID==nil)then
		self:Hide()
		return
	elseif(NPA_Tracker_Config["Tracker_Aura"]==1 and NPA_Tracker_Check(modulemain,"Aura"))then
		show=1
	elseif((NPA_Tracker_Config["Tracker_Cast"]==1 or NPA_Tracker_Config["Tracker_CastOnMe"]==1) and NPA_Tracker_Check(modulemain,"CastWarning"))then
		show=1
	elseif(NPA_Tracker_Config["Tracker_CrowdControl"]==1 and NPA_Tracker_Check(modulemain,"CrowdControl") )then
		show=1
	elseif(NPA_Tracker_Config["Tracker_CounterSpell"]==1 and NPA_Tracker_Check(modulemain,"CounterSpell"))then
		show=1
	elseif(NPA_Tracker_Config["Tracker_CoolDown"]==1 and NPA_Tracker_Check(modulemain,"CoolDown"))then
		show=1
	end

	local guid=self.GUID
	self.ModuleMain.GUID=guid


	local currentx=self:GetLeft() or 0
	local currenty=self:GetBottom() or 0

	local nTime=GetTime()

	local unitdata=GetUnitData(guid)
	if(unitdata==nil or show~=1 or (unitdata.GuessedHealth and unitdata.GuessedHealth<2) or (unitdata.LastLog==nil or nTime-unitdata.LastLog>NPA_Tracker_Config["Tracker_TimeOut"]) or NPA_Tracker_Enable~=1)then
		self:Hide()
		NPA_Tracker_GUIDList[guid]=nil

		NPA_Tracker_FrameSlot[self.Slot]=nil
		NPA_Tracker_Count=NPA_Tracker_Count-1

		self.GUID=nil

		self.TimeStack=0

		return
	else
		modulemain:SetAlpha(1)
	end

	local frame=GUIDToFrame[guid]
	local timestep=self.TimeStack

	if(frame and frame:IsShown())then
		local targetframe=frame
		local targetx=targetframe:GetLeft() or 0
		local targety=targetframe:GetBottom() or 0

		if(targetx<0)then
			targetx=0
		elseif(targetx>1068)then
			targetx=1068
		end

		if(targety<0)then
			targety=0
		elseif(targety>748)then
			targety=748
		end

		if(abs(currentx-targetx)>2 or abs(currenty-targety)>2)then
	
			local stepx=(targetx-currentx)*timestep*4
			local stepy=(targety-currenty)*timestep*4

			local x
			local y

			if(stepx<15 and stepy<15)then
				x=targetx
				y=targety
				modulemain:Hide()
			else
				x=currentx+stepx
				y=currenty+stepy
			end

			self:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",x,y)

			local alpha=(stepx+stepy)/400
			modulemain:SetAlpha(alpha)
		end

		if(self.Slot~=0)then
			NPA_Tracker_FrameSlot[self.Slot]=nil
			self.Slot=0
		end
	elseif(self.Slot==0)then
		for i=1,NPA_Tracker_Config["Tracker_Count"] do
			if(NPA_Tracker_FrameSlot[i]==nil or NPA_Tracker_FrameSlot[i]==0)then
				NPA_Tracker_FrameSlot[i]=self.Index
				self.Slot=i
	
				self.TargetX,self.TargetY=NPA_Tracker_FrameTargetPosition(i)
		
				modulemain:Show()

				modulemain:SetAlpha(1)

				break
			end
		end
	elseif(abs(currentx-self.TargetX)>2 or abs(currenty-self.TargetY)>2)then

		local stepx=(self.TargetX-currentx)*timestep*4
		local stepy=(self.TargetY-currenty)*timestep*4

		local x=currentx+stepx
		local y=currenty+stepy

		self:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",x,y)
	end

	self.TimeStack=0

end

local function NPA_ModuleMain_OnHide(self)
	local nametext=self["NameText"]
	if(nametext)then
		nametext:Hide()
	end
end

local function NPA_Tracker_CreateFrame(modulelist)
	local frame=CreateFrame("Frame","NPA_Tracker_Frame",NPA_Tracker_MainFrame)
	frame:SetHeight(20)
	frame:SetWidth(160)
	frame:Hide()
	frame:SetScript("OnUpdate",NPA_Tracker_FrameOnUpdate)

	--module mainframe


	local rendermain=CreateFrame("Frame","NPA_RenderMainFrame",frame)
	rendermain:SetHeight(1)
	rendermain:SetWidth(1)
	rendermain:SetPoint("CENTER",frame,"CENTER")
	rendermain.Attach=frame
	rendermain:Show()

	local modulemain=CreateFrame("Frame","NPA_RenderMainFrame",rendermain)
	modulemain:SetHeight(20)
	modulemain:SetWidth(120)
	modulemain:SetPoint("CENTER",frame,"CENTER")
	modulemain:Show()
	modulemain:SetScale(NPA_Tracker_Config["Tracker_Size"])

	modulemain.Parent=frame
	modulemain.TimeStack=100


	--scroll frame
	local scrollframe=CreateFrame("ScrollFrame","NPA_ScrollMainFrame",frame)
	scrollframe:SetHeight(512)
	scrollframe:SetWidth(512)
	scrollframe:SetPoint("CENTER",frame,"CENTER")
	scrollframe:SetScrollChild(rendermain)
	scrollframe:SetFrameStrata("BACKGROUND")
	scrollframe:Show()

	modulemain.RenderMain=scrollframe
	frame.IsTracker=1

	for name,key in pairs(modulelist) do
		if(key==1)then
			NPA_Core:HookFrame(name,modulemain)
		end
	end

	frame.ModuleMain=modulemain

	modulemain:SetScript("OnHide",NPA_ModuleMain_OnHide)

	NPA_Core:HookModuleMain(modulemain)
			

	frame.Slot=0
	frame.TimeStack=0

	return frame
end

local function NPA_Tracker_InitFrames()
	for i=1,NPA_Tracker_Config["Tracker_Count"] do
		if(not NPA_Tracker_Frame[i])then
			NPA_Tracker_Frame[i]=NPA_Tracker_CreateFrame(NPA_Tracker_Config["Tracker_ModuleList"])
			NPA_Tracker_Frame[i].Index=i
		elseif(NPA_Tracker_Frame[i]:IsShown() and NPA_Tracker_Frame[i].Slot~=0)then

			NPA_Tracker_Frame[i].TargetX,NPA_Tracker_Frame[i].TargetY=NPA_Tracker_FrameTargetPosition(NPA_Tracker_Frame[i].Slot)

			NPA_Tracker_Frame[i]:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",NPA_Tracker_Frame[i].TargetX,NPA_Tracker_Frame[i].TargetY)
		else
			NPA_Tracker_Frame[i]:Hide()
		end

		NPA_Tracker_Frame[i].ModuleMain:SetScale(NPA_Tracker_Config["Tracker_Size"])
		
	end

	if(NPA_Tracker_Config["Tracker_Self"]==1 and NPA_Tracker_Enable==1)then
		if(not NPA_Tracker_SelfFrame)then
			NPA_Tracker_SelfFrame=NPA_Tracker_CreateFrame(NPA_Tracker_Config["Tracker_SelfModuleList"])
		end
		local selfframe=NPA_Tracker_SelfFrame
		selfframe:SetPoint("CENTER",UIParent,"CENTER",NPA_Tracker_Config["Tracker_SelfOffsetX"],NPA_Tracker_Config["Tracker_SelfOffsetY"])
		selfframe.ModuleMain:SetScale(NPA_Tracker_Config["Tracker_SelfSize"])
		selfframe.ModuleMain:SetAlpha(NPA_Tracker_Config["Tracker_SelfAlpha"])

		selfframe.GUID=0

		local main=selfframe.ModuleMain
		for key,on in pairs(NPA_Config["Core"]) do
			if(main[key] and on~=1)then
				main[key]:Hide()
			end
		end

		local selfname=main["NameText"]
		if(not selfname)then
			selfname=selfframe.SelfName
		end

		if(selfname)then
			if(NPA_Tracker_Config["Tracker_SelfName"]==1)then
				main["NameText"]=selfname
				selfname:Show()
			else
				selfframe.SelfName=selfname
				selfname:Hide()
				main["NameText"]=nil
			end
		end

		selfframe.IsSelf=1

		selfframe:Show()
	else
		local guid=UnitGUID("player")
		if(guid)then
			GUIDToFrame[guid]=nil
		end

		if(NPA_Tracker_SelfFrame)then
			NPA_Tracker_SelfFrame:Hide()
		end
	end

	if(NPA_Tracker_Config["Tracker_Pet"]==1 and NPA_Tracker_Enable==1)then
		if(not NPA_Tracker_PetFrame)then
			NPA_Tracker_PetFrame=NPA_Tracker_CreateFrame(NPA_Tracker_Config["Tracker_PetModuleList"])
		end
		local petframe=NPA_Tracker_PetFrame
		petframe:SetPoint("CENTER",UIParent,"CENTER",NPA_Tracker_Config["Tracker_PetOffsetX"],NPA_Tracker_Config["Tracker_PetOffsetY"])
		petframe.ModuleMain:SetScale(NPA_Tracker_Config["Tracker_PetSize"])
		petframe.ModuleMain:SetAlpha(NPA_Tracker_Config["Tracker_PetAlpha"])

		petframe.GUID=-1

		local main=petframe.ModuleMain
		for key,on in pairs(NPA_Config["Core"]) do
			if(main[key] and on~=1)then
				main[key]:Hide()
			end
		end

		local petname=main["NameText"]
		if(not petname)then
			petname=petframe.PetName
		end

		if(petname)then
			if(NPA_Tracker_Config["Tracker_PetName"]==1)then
				main["NameText"]=petname
				petname:Show()
			else
				petframe.PetName=petname
				petname:Hide()
				main["NameText"]=nil
			end
		end

		petframe.IsPet=1
		petframe:Show()
	else
		local guid=UnitGUID("playerpet")
		if(guid)then
			GUIDToFrame[guid]=nil
		end

		if(NPA_Tracker_PetFrame)then
			NPA_Tracker_PetFrame:Hide()
		end
	end
end


local function NPA_Tracker_OnEvent(uarg)
	if(NPA_Tracker_GUIDList[uarg[6]]==nil and NPA_Tracker_Count<NPA_Tracker_Config["Tracker_Count"])then
		local myguid=UnitGUID("player")
		local petguid=UnitGUID("playerpet") or 0
		local filter=NPA_Tracker_CombatLogFilter[uarg[2]]
		if(filter==1 and
			uarg[6] and uarg[6]~=myguid and uarg[6]~=petguid)then

			NPA_Tracker_AddTracker(uarg[6],uarg[8])

		elseif(((uarg[6]==myguid and filter==3) or filter==2) and
			uarg[3] and uarg[3]~=myguid and uarg[3]~=petguid )then
		
			NPA_Tracker_AddTracker(uarg[3],uarg[5])
		end
	end
end

function NPA_Tracker:ApplyConfig()
	NPA_Core:CheckConfigEntry("Tracker",NPA_Tracker_DefaultSetting)

	NPA_Tracker_Config=NPA_Config["Tracker"]
	NPA_Tracker_Enable=NPA_Config["Core"]["Tracker"]

	NPA_Tracker_MainFrame:SetPoint("CENTER",UIParent,"CENTER",NPA_Tracker_Config["Tracker_OffsetX"],NPA_Tracker_Config["Tracker_OffsetY"])

	NPA_Tracker_BuildFilter()
	NPA_Tracker_InitFrames()

	if(NPA_Config["Core"]["Tracker"]==1)then
		NPA_Core.CombatEventFunc["Tracker"]=NPA_Tracker_OnEvent
	else
		NPA_Core.CombatEventFunc["Tracker"]=nil
	end

end


function NPA_Tracker:ClearData()
	
end


local function NPA_Tracker_AddFrame(guid)
	for j=1,NPA_Tracker_Config["Tracker_Count"] do
		if(not NPA_Tracker_Frame[j]:IsShown()) then
			local frame=NPA_Tracker_Frame[j]
			frame:EnableMouse(false)
		
			frame:Show()
			frame.GUID=guid

			frame.TimeStack=0

			frame.ModuleMain:Show()
			frame.ModuleMain.GUID=guid
			
			frame.ModuleMain:SetAlpha(0.01)

			frame.Slot=0
		
			NPA_Tracker_GUIDList[guid]=1

			NPA_Tracker_Count=NPA_Tracker_Count+1

			return
		end	
	end
	
end

local function NPA_Tracker_MainFrame_OnUpdate(self,elapsed)
	self.TimeStack=self.TimeStack+elapsed
	if(self.TimeStack<NPA_Tracker_Config["Tracker_UpdateInterval"])then
		return
	end
	self.TimeStack=0


	local nTime=GetTime()
	for i,guid in pairs(NPA_Tracker_TrackList) do
		if(GetUnitData(guid) and NPA_Tracker_GUIDList[guid]==nil and NPA_Tracker_Count<NPA_Tracker_Config["Tracker_Count"])then
			NPA_Tracker_AddFrame(guid)
		end

		table_remove(NPA_Tracker_TrackList,i)
	end

end

NPA_Tracker_MainFrame.TimeStack=0

NPA_Tracker_MainFrame:SetScript("OnUpdate",NPA_Tracker_MainFrame_OnUpdate)
NPA_Tracker_MainFrame:SetHeight(1)
NPA_Tracker_MainFrame:SetWidth(1)


NPA_Core:AddModule("Tracker",NPA_Tracker)