﻿-- Author      : Nogarder
-- Create Date : 2010/7/4 16:33:11

if(NPA_Core:CheckHook("NameText"))then


local Localization={}
local Tooltips={}
local locale=GetLocale()
local table_insert = table.insert
local pairs = pairs

if(locale=="zhTW")then
	Localization={
		["PageName"]="姓名文本",
		["NameByFaction"]="用陣營著色姓名",
		["BoldHostileName"]="不隱藏敵對",
		["BoldNonHostileName"]="不隱藏非敵對",
		["NameByClass"]="用職業著色姓名",
		["ShowGuild"]="顯示工會名",
		["HideWithHealthBar"]="血條隱藏時也隱藏",
		["ShowMark"]="顯示標記",
		["MarkTarget"]="標記我的目標",
		["MarkGuildMember"]="標記工會成員",
		["MarkFriend"]="標記我的好友",
		["MarkRaidMember"]="標記團隊成員",
		["MarkPartyMember"]="標記小隊成員",
		["MarkHideInInstance"]="副本中隱藏標記",
		["MarkColorByType"]="標記按類型上色",
		["ShowName"]="顯示姓名",
		["OnlyPlayerName"]="只顯示玩家姓名",
		["HideTotemName"]="隱藏圖騰名",
		["HideGuildInInstance"]="副本中隱藏工會",
		["MarkPartyAsRaid"]="在團隊中時將小隊標記為團隊",
		["Name"]="姓名",
		["Guild"]="工會",
		["Mark"]="標記",
		["FullName"]="顯示軍銜和頭銜",
		["Tapped"]="標記屬於它人的怪物",
		["ShowHostilePortrait"]="顯示敵對目標頭像",
		["ShowNonHostilePortrait"]="顯示非敵對目標頭像",
		["ShowPartyPortrait"]="顯示小隊成員頭像",
		["ShowGuildPortrait"]="顯示工會成員頭像",
		["ShowRaidPortrait"]="顯示團隊成員頭像",
		["Portrait"]="頭像",
		["ShowPortrait"]="啟動頭像(提高資源佔用)(需要重載UI)",
		["ShowOnlyPlayerPortrait"]="只顯示玩家頭像",
		["AutoHideGuild"]="姓名板不淡化時隱藏工會",
		["ColorTarget"]="著色目標名稱",
		["ColorFocus"]="著色focus名稱",
		["ColorMouseover"]="著色鼠標滑過名稱",
		["MarkFocus"]="標記focus",
		["MarkMouseover"]="標記鼠标滑过",
	}
	Tooltips={
		["NameText"]="顯示單位的姓名,工會,頭像,以及目標/鼠標滑過/focus的特殊標記"
	}
elseif(locale=="zhCN")then
	Localization={
		["PageName"]="姓名文本",
		["NameByFaction"]="用阵营着色姓名",
		["BoldHostileName"]="不隐藏敌对",
		["BoldNonHostileName"]="不隐藏非敌对",
		["NameByClass"]="用职业着色姓名",
		["ShowGuild"]="显示工会名",
		["HideWithHealthBar"]="当血条隐藏时隐藏",
		["ShowMark"]="显示标记",
		["MarkTarget"]="标记我的目标",
		["MarkGuildMember"]="标记工会成员",
		["MarkFriend"]="标记我的好友",
		["MarkRaidMember"]="标记团队成员",
		["MarkPartyMember"]="标记小队成员",
		["MarkHideInInstance"]="副本中隐藏标记",
		["MarkColorByType"]="标记按类型上色",
		["ShowName"]="显示姓名",
		["OnlyPlayerName"]="只显示玩家姓名",
		["HideTotemName"]="隐藏图腾名",
		["HideGuildInInstance"]="副本中隐藏工会",
		["MarkPartyAsRaid"]="在团队中时将小队标记为团队",
		["Name"]="姓名",
		["Guild"]="工会",
		["Mark"]="标记",
		["FullName"]="显示军衔和头衔",
		["Tapped"]="标记属于它人的怪物",
		["ShowHostilePortrait"]="显示敌对目标头像",
		["ShowNonHostilePortrait"]="显示其它非敌对目标头像",
		["ShowPartyPortrait"]="显示小队成员头像",
		["ShowGuildPortrait"]="显示工会成员头像",
		["ShowRaidPortrait"]="显示团队成员头像",
		["Portrait"]="头像",
		["ShowPortrait"]="启动头像(提高资源占用)(需要重载UI)",
		["ShowOnlyPlayerPortrait"]="只显示玩家头像",
		["AutoHideGuild"]="姓名板不淡化时隐藏工会",
		["ColorTarget"]="着色目标名称",
		["ColorFocus"]="着色focus名称",
		["ColorMouseover"]="着色鼠标滑过名称",
		["MarkFocus"]="标记focus",
		["MarkMouseover"]="标记鼠标滑过",

	}
	Tooltips={
		["NameText"]="显示单位的姓名,工会,头像,以及目标/鼠标滑过/focus的特殊标记"
	}
else
	Localization={
		["PageName"]="NameText",
		["NameByFaction"]="Color name by faction",
		["BoldHostileName"]="Don't fade hostile",
		["BoldNonHostileName"]="Don't fade non-hostile",
		["NameByClass"]="Color name by class",
		["ShowGuild"]="Show guild",
		["HideWithHealthBar"]="Hide with healthbar",
		["ShowMark"]="Show mark",
		["MarkTarget"]="Mark my target",
		["MarkGuildMember"]="Mark guild member",
		["MarkFriend"]="Mark my friend",
		["MarkRaidMember"]="Mark raid member",
		["MarkPartyMember"]="Mark party member",
		["MarkHideInInstance"]="Hide mark in instance",
		["MarkColorByType"]="Color mark by type",
		["ShowName"]="Show name",
		["OnlyPlayerName"]="Show only player name",
		["HideTotemName"]="Hide totem name",
		["HideGuildInInstance"]="Hide guild in instance",
		["MarkPartyAsRaid"]="Mark party as raid if in raid",
		["Name"]="Name",
		["Guild"]="Guild",
		["Mark"]="Mark",
		["FullName"]="Show rank and title",
		["Tapped"]="Show tapped",
		["ShowHostilePortrait"]="Show hostile portrait",
		["ShowNonHostilePortrait"]="Show other non-hostile portrait",
		["ShowPartyPortrait"]="Show party member portrait",
		["ShowGuildPortrait"]="Show guild member portrait",
		["ShowRaidPortrait"]="Show raid member portrait",
		["Portrait"]="Portrait",
		["ShowPortrait"]="Enable Portrait (increase cpu cost)(require ui reload)",
		["ShowOnlyPlayerPortrait"]="Show only player portrait",
		["AutoHideGuild"]="Hide guild when nameplate not fading",
		["ColorTarget"]="Color target name",
		["ColorFocus"]="Color focus name",
		["ColorMouseover"]="Color mouseover name",
		["MarkFocus"]="Mark focus",
		["MarkMouseover"]="Mark mouseover",
	}
	Tooltips={
		["NameText"]="Show name,guild,portrait for unit, and special mark for target/mouseover/focus"
	}

end


local mainframe=NPA_Options:AddPage("NPA_Options_NameText",Localization["PageName"],"NameText",Tooltips["NameText"])

local Options=mainframe.Options


NPA_Options:CreateSliderEditButton(Localization["Name"],mainframe,"NameText_TextData",2,Options,1)
NPA_Options:CreateSliderEditButton(Localization["Guild"],mainframe,"NameText_GuildData",2,Options,2)

NPA_Options:CreateSliderEditButton(Localization["Mark"],mainframe,"NameText_MarkData",3,Options,3.5)


NPA_Options:CreateSliderEditButton(Localization["Portrait"],mainframe,"NameText_PortraitData",3,Options,5)

-----------------
local listframe=NPA_Options:CreateFrame("NPA_Options_NameText_Filter",mainframe)
listframe:SetPoint("TOPRIGHT",-6,-6)
listframe:SetHeight(360)
listframe:SetWidth(200)

local checkboxdata={
	["NameText_Name"]=Localization["ShowName"],
	["NameText_Guild"]=Localization["ShowGuild"],
	["NameText_Mark"]=Localization["ShowMark"],
	["NameText_OnlyPlayerName"]=Localization["OnlyPlayerName"],
	["NameText_HideTotemName"]=Localization["HideTotemName"],
	["NameText_HideGuildInInstance"]=Localization["HideGuildInInstance"],
	["NameText_AutoHideGuild"]=Localization["AutoHideGuild"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe,21,checkboxdata,17,Options,1)

local listframe4=NPA_Options:CreateFrame("NPA_Options_NameText_Filter",mainframe)
listframe4:SetPoint("TOPLEFT",listframe,"BOTTOMLEFT",0,3)
listframe4:SetPoint("TOPRIGHT",listframe,"BOTTOMRIGHT",0,3)

local checkboxdata={
	["NameText_BoldHostile"]=Localization["BoldHostileName"],
	["NameText_BoldNonHostile"]=Localization["BoldNonHostileName"],
	["NameText_FullName"]=Localization["FullName"],
	["NameText_Tapped"]=Localization["Tapped"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe4,21,checkboxdata,17,Options,1)


local listframe5=NPA_Options:CreateFrame("NPA_Options_NameText_Filter",mainframe)
listframe5:SetPoint("TOPLEFT",listframe4,"BOTTOMLEFT",0,3)
listframe5:SetPoint("TOPRIGHT",listframe4,"BOTTOMRIGHT",0,3)

local checkboxdata={
	["NameText_ShowHostilePortrait"]=Localization["ShowHostilePortrait"],
	["NameText_ShowNonHostilePortrait"]=Localization["ShowNonHostilePortrait"],
	["NameText_ShowPartyPortrait"]=Localization["ShowPartyPortrait"],
	["NameText_ShowRaidPortrait"]=Localization["ShowRaidPortrait"],
	["NameText_ShowGuildPortrait"]=Localization["ShowGuildPortrait"],
	["NameText_ShowPortrait"]=Localization["ShowPortrait"],
	["NameText_ShowOnlyPlayerPortrait"]=Localization["ShowOnlyPlayerPortrait"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe5,21,checkboxdata,17,Options,1)

local listframe3=NPA_Options:CreateFrame("NPA_Options_NameText_Filter2",mainframe)
listframe3:SetPoint("TOPLEFT",listframe5,"BOTTOMLEFT",0,3)
listframe3:SetPoint("TOPRIGHT",listframe5,"BOTTOMRIGHT",0,3)

local checkboxdata={
	["NameText_NameByClass"]=Localization["NameByClass"],
	["NameText_NameByFaction"]=Localization["NameByFaction"],
	["NameText_HideWithHealthBar"]=Localization["HideWithHealthBar"],
	["NameText_ColorTarget"]=Localization["ColorTarget"],
	["NameText_ColorFocus"]=Localization["ColorFocus"],
	["NameText_ColorMouseover"]=Localization["ColorMouseover"]
}
NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe3,21,checkboxdata,17,Options,1)

local listframe2=NPA_Options:CreateFrame("NPA_Options_NameText_Filter3",mainframe)
listframe2:SetWidth(200)
listframe2:SetPoint("TOPRIGHT",listframe,"TOPLEFT",-3,0)

local checkboxdata={
	["NameText_MarkTarget"]=Localization["MarkTarget"],
	["NameText_MarkFriend"]=Localization["MarkFriend"],
	["NameText_MarkRaidMember"]=Localization["MarkRaidMember"],
	["NameText_MarkGuildMember"]=Localization["MarkGuildMember"],
	["NameText_MarkPartyMember"]=Localization["MarkPartyMember"],
	["NameText_MarkHideInInstance"]=Localization["MarkHideInInstance"],
	["NameText_MarkColorByType"]=Localization["MarkColorByType"],
	["NameText_MarkPartyAsRaid"]=Localization["MarkPartyAsRaid"],
	["NameText_MarkFocus"]=Localization["MarkFocus"],
	["NameText_MarkMouseover"]=Localization["MarkMouseover"],
}

NPA_Options:BuildCheckBoxList("NPA_Options_NameText",listframe2,21,checkboxdata,17,Options,1)
end